code	segment	public 'CODE'
	assume	cs:code, ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	80h
tail	label	byte			; pointer to command line tail

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0			; extra word to hold far jump segment

int2f:	cmp	ax,1503h		; check for Abstract File Name function
	jne	start			; jump to previous handler in chain if not

	push	ds			; save registers used on stack
	push	ax
	push	cx
	push	si
	push	di

	push	cs			; data seg = code seg
	pop	ds

	xor	ax,ax			; AH = fill flag, AL = byte to store
	mov	cx,38			; size of return buffer in bytes
	mov	si,offset tail+2	; copy from command line tail in PSP
	mov	di,bx			; copy to return buffer at ES:BX

cloop:	or	ah,ah			; if flag is set, just store the fill byte
	jnz	store
	lodsb
	cmp	al,0dh			; if it's not a CR, continue copying
	jnz	store
	mov	ax,0120h		; reached the CR, set fill flag and byte
store:	stosb
	loop	cloop

	pop	di			; restore registers
	pop	si
	pop	cx
	pop	ax
	pop	ds

	iret				; return from interrupt

init:	cmp	byte ptr[tail],0	; check for command line parameter
	jz	noparm
       
	mov	ax,1500h		; check for installed CD driver
	xor	bx,bx
	int	2fh
	or	bx,bx
	jz	nocdex

	mov	ax,352fh		; create far jump to previous int handler
	int	21h
	mov	al,0eah
	mov	byte ptr [start],al
	mov	word ptr [start+1],bx
	mov	word ptr [start+3],es

	mov	dx,offset int2f		; hook into the chain
	mov	ax,252fh
	int	21h

	mov	es,word ptr[envseg]	; free the environment seg to save memory
	mov	ah,49h
	int	21h

	mov	dx,offset mess1		; display the installed message
	mov	ah,09h
	int	21h

	mov	dx,0013h		; terminate, leaving DX paragraphs resident
	mov	ax,3100h
	int	21h

noparm:	mov	dx,offset mess2		; display usage if no parameter given
	jmp	exit

nocdex:	mov	dx,offset mess3		; display warning if CD driver not installed

exit:	mov	ah,09h
	int	21h

	mov	ax,4c00h		; exit to DOS
	int	21h

mess1	db	'Abstract File Name TSR installed$'
mess2	db	'Usage: ABSTRACT character_string$'
mess3	db	'MSCDEX must be installed!$'

code	ends
	end	start
